<?php
/*
** Zabbix
** Copyright (C) 2001-2020 Zabbix SIA
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
**/


class CWidgetFieldMsHost extends CWidgetFieldMs {

	/**
	 * ID for Host group Multiselect element used to prefill Application PoPup Host group filter.
	 * Analog for multiselect filter_preselect_fields['hostgroups'] property.
	 *
	 * @var string  (nullable) ID for Multiselect element.
	 */
	public $filter_preselect_host_group_field;

	/**
	 * Create widget field for Host selection
	 *
	 * @param string      $name     field name in form
	 * @param string      $label    label for the field in form
	 */
	public function __construct($name, $label) {
		parent::__construct($name, $label);

		$this->setSaveType(ZBX_WIDGET_FIELD_TYPE_HOST);
	}
}
